|
|
#!/bin/sh # # --- ROCK-COPYRIGHT-NOTE-BEGIN --- # # This copyright note is auto-generated by ./scripts/Create-CopyPatch. # Please add additional copyright information _after_ the line containing # the ROCK-COPYRIGHT-NOTE-END tag. Otherwise it might get removed by # the ./scripts/Create-CopyPatch script. Do not edit this copyright text! # # ROCK Linux: rock-src/target/livecd/fixedfiles/system # ROCK Linux is Copyright (C) 1998 - 2004 Clifford Wolf # # This program is free software; you can redistribute it and/or modify # it under the terms of the GNU General Public License as published by # the Free Software Foundation; either version 2 of the License, or # (at your option) any later version. A copy of the GNU General Public # License can be found at Documentation/COPYING. # # Many people helped and are helping developing ROCK Linux. Please # have a look at http://www.rocklinux.org/ and the Documentation/TEAM # file for details. # # --- ROCK-COPYRIGHT-NOTE-END --- # # Desc: System bootup and shutdown # Runlevel: 01 rcX rc1 rc2 rc3 rc4 rc5 #
title() { local x w="$( stty size 2>/dev/null </dev/tty | cut -d" " -f2 )" [ -z "$w" ] && w="$( stty size </dev/console | cut -d" " -f2 )" for (( x=1; x<w; x++ )) do echo -n .; done echo -e "\e[222G\e[3D v \r\e[36m$* \e[0m" error=0 }
status() { if [ $error -eq 0 ] then echo -e "\e[1A\e[222G\e[4D\e[32m :-)\e[0m" else echo -e "\e[1A\e[222G\e[4D\a\e[1;31m :-(\e[0m" fi }
case "$1" in start) title "Runnind depmod ..." /sbin/depmod -a -n > /etc/modules.dep || error=$? status
title "Mounting /sys, /dev/shm and /dev/pts." mount -n /sys 2> /dev/null mount -n /dev/shm || error=$? mount -n /dev/pts 2> /dev/null if [ -f /etc/conf/hardware ] ; then . /etc/conf/hardware fi status
title "Configuring the /dev filesystem ..." sh /etc/conf/devfs || error=$? status
title "Configuring hardware by activating rockplug." echo "/sbin/rockplug" > /proc/sys/kernel/hotplug for file in /etc/rockplug/*.init ; do [ -f $file ] && $file start done status
title "Loading kernel modules and configuring the kernel." sh /etc/conf/kernel || error=$?
[ -f /etc/conf/clock ] && . /etc/conf/clock if [ "$clock_tz" = localtime ] ; then status
title "Setting kernel clock to local time." hwclock --hctosys --localtime || error=$? fi if [ "$clock_rtc" ] ; then status
title "Setting enhanced real time clock precision to $clock_rtc." if [ -w /proc/sys/dev/rtc/max-user-freq ] ; then echo $clock_rtc > /proc/sys/dev/rtc/max-user-freq || error=$? else echo "No /proc/sys/dev/rtc/max-user-freq found." fi fi status
title "Setting hostname to $(cat /etc/HOSTNAME)." hostname "$(cat /etc/HOSTNAME)" || error=$? status
title "Refresh utmp, delete lock and tmp files and other stuff." find /var/lock /var/run /tmp -mindepth 1 -print0 2> /dev/null | xargs --null rm -rf rm -f /etc/nologin /nologin /fastboot ; touch /var/run/utmp chmod 664 /var/run/utmp ; chown root:tty /var/run/utmp status
title "Writing /var/log/boot.msg." klogd -f /var/log/boot.msg -o ; dmesg -n 3 status
title "Setting keyboard keymappings." if [ -L /etc/default.keymap ] ; then mapfile=$(ls -l /etc/default.keymap | sed 's,.* -> ,,') loadkeys $mapfile || error=$? elif [ -f /etc/default.keymap ] ; then loadkeys /etc/default.keymap || error=$? else echo "No /etc/default.keymap found." fi status
title "Setting keyboard repeat rate and delay time." kbd_rate=30; kbd_delay=250 [ -f /etc/conf/kbd ] && . /etc/conf/kbd /usr/bin/kbdrate -r $kbd_rate -d $kbd_delay < /dev/console || error=$? status
title "Setting console screen font." if [ -L /etc/default.vcfont ] ; then fontfile=$(ls -l /etc/default.vcfont | sed 's,.* -> ,,') setfont $fontfile || error=$? elif [ -f /etc/default.vcfont ] ; then setfont /etc/default.vcfont || error=$? else echo "No /etc/default.vcfont found." fi status
title "Setting console terminal type and blank interval." con_term=linux; con_blank=0 [ -f /etc/conf/console ] && . /etc/conf/console /usr/bin/setterm -term $con_term -blank $con_blank > /dev/console || error=$? status
title "Setting up loopback networking." ip link set lo up || error=$? ip addr add 127.0.0.1/8 dev lo || error=$? ip route add 127/8 dev lo || error=$? status
title "Setting overflow UID and GID kernel parameters." sysctl -w kernel.overflowuid=$(id -u nobody) > /dev/null || error=$? sysctl -w kernel.overflowgid=$(id -g nobody) > /dev/null || error=$? status
title "Reading /etc/sysctl.conf file." sysctl -p || error=$? status
title "Initializing kernel random number generator." if [ -e /var/state/random-seed ] ; then cat /var/state/random-seed >/dev/urandom || error=$? fi status
title "Setting mixer devices Master and PCM to 65%." /usr/bin/amixer sset PCM 20 >/dev/null 2>&1 || error=$? /usr/bin/amixer sset PCM unmute >/dev/null 2>&1 || error=$? /usr/bin/amixer sset Master 20 >/dev/null 2>&1 || error=$? /usr/bin/amixer sset Master unmute >/dev/null 2>&1 || error=$? status ;;
stop) title "Saving /var/log/init.msg and /var/log/boot.msg." touch /var/log/init.msg /var/log/boot.msg || error=$? mv /var/log/init.msg /var/log/init.old || error=$? mv /var/log/boot.msg /var/log/boot.old || error=$? status
title "Writing a wtmp record." if [ "$RUNLEVEL" = 0 ] ; then halt -w || error=$? else reboot -w || error=$? ; fi status
title "Saving kernel random seed." dd if=/dev/urandom of=/var/state/random-seed count=1 2> /dev/null status
title "Sending all processes a SIGTERM (15)." killall5 -15 || error=$? ; sleep 5 status
title "Sending all processes a 2nd SIGTERM (15)." killall5 -15 || error=$? ; sleep 5 status
title "Sending all processes a SIGKILL (9)." killall5 -9 || error=$? ; sleep 5 status
title "Turning off swap devices." swapoff -a || error=$? sync ; sleep 1 status
title "Remounting sync/ro and umount filesystems." cut -d' ' -f-3 /etc/mtab /proc/mounts | sort -k2 -u -r | \ while read dev dir fs ; do [ "$dir" = "/" ] && continue [ "$dir" = "/dev" ] && continue [ "$dir" = "/dev/shm" ] && continue [ "$dir" = "/proc" ] && continue [ "$dir" = "/sys" ] && continue [ "$dir" = "/tmp" ] && continue echo "Umounting $dev on $dir ($fs)." mount -o remount,sync $dir mount -o remount,ro $dir umount -d $dir done status
title "Unmounting remaining file systems." grep -E -v '^none (/|[a-z]+:) ' /proc/mounts > /etc/mtab sync ; sleep 1 ; sync umount -vdnra -t nodevfs,proc,sysfs,shm mount -vn -o remount,sync / mount -vn -o remount,ro / sleep 1 ; sync ; sleep 1 status
command="" [ "$RUNLEVEL" = 0 ] && command=halt [ "$RUNLEVEL" = 6 ] && command=reboot if [ -n "$command" ] ; then echo "Going to $command the system ..." $command -d -f -i -p while true ; do sleep 1 ; done fi ;;
restart) $0 stop; $0 start ;;
*) echo "Usage: $0 { start | stop }" exit 1 ;;
esac
exit 0
|